// This program calculates the number of Hamiltonian paths 
// in a 3x3x3 graph, see:
// http://physicsforums.com/showthread.php?t=460112

// Here, the Hamiltonian paths are not numbered to speed up the 
// calculation. 
  

#include<iostream>
#include<vector>
using namespace std;


// This is the recursive function
void visitNeighbours(int v, vector<int> visited, int lengthPath, vector<int>* adjList, int endVertex, int& counter){

	if(lengthPath==27 && v==endVertex){
		counter++;
	}
	
	else{
		
		vector<int>::iterator itr;
		itr=adjList[v].begin();
		
		while(itr<adjList[v].end()){        // python: for i in list => C++: use iterator itr
			if(visited[*itr]==0 && !(*itr==endVertex && lengthPath+1<27) ){
				
			   vector<int> visitedCopy;
			   visitedCopy = visited;   // luckily this is not a "copy by reference"
			   visitedCopy[*itr]=1;
				
			   	
			   visitNeighbours(*itr,visitedCopy,lengthPath+1,adjList,endVertex,counter);
			}
		itr++;      // iterator moves
		}
	}
}  














int main(){

	// main program
	cout << "PROGRAM STARTS" << endl;


	vector<int> adjList[27];
	
	
	
	
	// begin: define your graph ---------------------------------------------------
	// node0
	int node0[] = {1,3,9};
	adjList[0].assign(node0,node0+3);  // the "+3" comes from the length of the array 'node0[]'
	
	// node1
	int node1[] = {0,2,4,10};
	adjList[1].assign(node1,node1+4);  // here "+4" since the array has 4 elements
	
	// node2
	int node2[] = {1,5,11};
	adjList[2].assign(node2,node2+3);  // here "+3" since the array has 3 elements
	
	//-----------------------------------------------------------------------------------------
	
	// node3
	int node3[] = {0,4,6,12};
	adjList[3].assign(node3,node3+4);
	
	// node4
	int node4[] = {1,3,5,7,13};
	adjList[4].assign(node4,node4+5);
	
	// node5
	int node5[] = {2,4,8,14};
	adjList[5].assign(node5,node5+4);
	
	//----------------------------------------------------------------------------------------
	
	// node6
	int node6[] = {3,7,15};
	adjList[6].assign(node6,node6+3);
	
	// node7
	int node7[] = {4,6,8,16};
	adjList[7].assign(node7,node7+4);
	
	// node8
	int node8[] = {5,7,17};
	adjList[8].assign(node8,node8+3);
	
	//---------------------------------------------------------------------------------------
	
	// node9
	int node9[] = {0,10,12,18};
	adjList[9].assign(node9,node9+4);
	
	// node10
	int node10[] = {1,9,11,13,19};
	adjList[10].assign(node10,node10+5);
	
	// node11
	int node11[] = {2,10,14,20};
	adjList[11].assign(node11,node11+4);
	
	//---------------------------------------------------------------------------------------
	
	// node12
	int node12[] = {3,9,13,15,21};
	adjList[12].assign(node12,node12+5);
	
	// node13
	int node13[] = {4,10,12,14,16,22};
	adjList[13].assign(node13,node13+6);
	
	// node14
	int node14[] = {5,11,13,17,23};
	adjList[14].assign(node14,node14+5);
	
	//---------------------------------------------------------------------------------------------
	
	// node15
	int node15[] = {6,12,16,24};
	adjList[15].assign(node15,node15+4);
	
	// node16
	int node16[] = {7,13,15,17,25};
	adjList[16].assign(node16,node16+5);
	
	// node17
	int node17[] = {8,14,16,26};
	adjList[17].assign(node17,node17+4);
	
	
	//---------------------------------------------------------------------------------------------
	
	// node18
	int node18[] = {9,19,21};
	adjList[18].assign(node18,node18+3);
	
	// node19
	int node19[] = {10,18,20,22};
	adjList[19].assign(node19,node19+4);
	
	// node20
	int node20[] = {11,19,23};
	adjList[20].assign(node20,node20+3);
	
	//---------------------------------------------------------------------------------------------
	
	// node21
	int node21[] = {12,18,22,24};
	adjList[21].assign(node21,node21+4);
	
	// node22
	int node22[] = {13,19,21,23,25};
	adjList[22].assign(node22,node22+5);
	
	// node23
	int node23[] = {14,20,22,26};
	adjList[23].assign(node23,node23+4);
	
	//---------------------------------------------------------------------------------------------
	
	// node24
	int node24[] = {15,21,25};
	adjList[24].assign(node24,node24+3);
	
	// node25
	int node25[] = {16,22,24,26};
	adjList[25].assign(node25,node25+4);
	
	// node26
	int node26[] = {17,23,25};
	adjList[26].assign(node26,node26+3);
	
	
	// end: define your graph  ---------------------------------------------------
	
	
	
	// This array tells us if a vertex has already been visited.
	vector<int> visited;
	for(int i=0; i<27; i++){
		visited.push_back(0);
	}
	
	// Start and end vertex
	int startVertex=0;
	int endVertex=26;
	
	// Initialize data structures
	visited[startVertex]=1;
	int counter = 0;
	int lengthPath = 1;
	
	visitNeighbours(startVertex,visited,lengthPath,adjList,endVertex,counter);
	
	cout << "Number of Hamiltonian paths: " << counter << endl;
	cout << "PROGRAM ENDS" << endl;
	
	
	return 0;
}



/*
PROGRAM STARTS
Number of Hamiltonian paths: 38256
PROGRAM ENDS

real	0m42.929s
user	0m42.755s
sys	0m0.040s

*/







